;===============================================================
;   ,     1  20  
; ( ).     
;    .     AT90S1200.
;        
;.
;==============================================================
.INCLUDE     "1200def.inc"
.eseg
.org         $000
eeconst:    .db $21,$7d,$13,$19,$4d,$89,$81,$3d,$1,$9  ;    EEPROM
.cseg
.ORG 000
                    rjmp reset		; 

;==============================================================
;     
; /.
;==============================================================
.ORG 002				;  /
timer:		in r5,sreg		;   
		out tcnt0,r0		;   
		dec r1			;    
		brne exit_timer	;    Z=0
		ldi r31,39		
		mov r1,r31
		dec r2			;    
		brne exit_timer	;    Z=0
		ldi r31,60
		mov r2,r31
		dec r17		;      
		brne exit_timer	;    Z=0
		ldi r17,9
		dec r18		;      
exit_timer:	out sreg,r5
                   	reti				;   

;===============================================================
;       .
;===============================================================
reset:
                  	ldi r31,$ff			;  
                  	out ddrb,r31			;    
                  	ldi r31,$ff			;      .1           
                 	out portb,r31
                  	ldi r31,$70			;  D
                  	out ddrd,r31			;PD0,PD1,PD2,PD3- , PD4,PD5,PD6- - 
                  	ldi r31,$f      
                  	out portd,r31              		;      D
                  	ldi r31,$05			;  
                  	out tccr0,r31			;     c  1:1024
                  	ldi r31,$2
                  	out timsk,r31			;   
                  	ldi r17,$4			;   
		ldi r18,$0
		ldi r31,$5e
		mov r0,r31
		ldi r31,$27
		mov r1,r31
	ldi r31,$3c	
                  	mov r2,r31
                  	ldi r24,$0			;    
scan:
                 	rcall izobr			;    
                 	sbis pind,0	 		;   "+"(PD0)
                 	rjmp plus			;        
                 	sbis pind,1			;   "-"(PD1)
                 	rjmp minus			;        
                 	sbis pind,2	 		;   "On/Pause"(PD2)
                 	rjmp start			;   
                 	rjmp scan		 	;   ,      
plus:
                 	ldi r31,$2			;    
                 	cpse r31,r18			;,    
                 	rjmp plus1			; ,        
                 	rcall standart			;   
                 	rcall pause			;  
                 	rjmp scan			;    
plus1:
                 	ldi r31,$9			;    
                 	cpse r17,r31			;,    
                 	rjmp plus2			; ,        
                 	inc r18				;  ,       1
                 	clr r17				;   
                 	rcall standart			;   
                 	rcall pause			;  
                 	rjmp scan			;    
plus2:
                	inc r17				;     1
                 	rcall standart			;   
                 	rcall pause			;  
                 	rjmp scan			;    
minus:
                	ldi r31,$0			;       
                	cpse r31,r18			;,      
                	rjmp minus1			; ,        
                	cpse r31,r17			;,      
                	rjmp minus2			; ,        
                	rcall standart			;   
                 	rcall pause			;  
                	rjmp scan			;    
minus1:
                	cpse r31,r17			;,      
                	rjmp minus2			; ,        
                	dec r18			;        1
                	ldi r17,$9			;      9
                	rcall standart			;   
                	rcall pause			;  
                	rjmp scan			;    
minus2:
                	dec r17		 	;     1
                	rcall standart			;   
                	rcall pause			;  
                	rjmp scan			;    
start:						;      
                	sbi portd,4		 	; . 1    (PD3)
                	out tcnt0,r0			;  /    
                	sei				; 
                	rcall pause			;  
                	rjmp start1			;   
start1:
                	rcall izobr			;    
                	sbis pind,2		 	;   "On/Pause"(PD2)
                	rjmp stop			;    
                	ldi r31,$0			; ,    
                	cpse r31,r18			;   
                	rjmp start1
                	cpse r31,r17			;   
               	rjmp start1
                	rjmp stop			;  ,        
stop:
                	cli				;        
                	cbi portd,4			;    (PD3)  . 0
                	rcall pause			;  
                	rjmp scan			;     
;=============================================================
;  ,
;        
;      "+"  "-".
;=============================================================
standart: 
                  	ldi r31,$2
D_3:		clr	r7
D_2:		clr	r8
D_1:		dec	r8
		brne	D_1
		dec            r7
		brne	D_2
		dec	R31	
		brne	D_3
                 	sbic pind,1
                 	rjmp exit7
                 	sbic pind,0
                 	rjmp exit7
                	ldi r17,$4			;   
                	ldi r18,$0
                 	rjmp exit7
exit7:
                	ret				;  
;==============================================================
; .         ,    ,        .
;==============================================================
pause:
                  	ldi r31,$5
D100_3:	clr	r7	 		; 
D100_2:	clr	r8	 		; 
D100_1:	dec	r8			;     
		brne	D100_1		;  
		dec            r7			;     
		brne	D100_2		;  
		dec	R31			;     
		brne	D100_3		;  
		ret				;  

;=============================================================
;     .
;==============================================================
izobr:
                  	inc r16				;    1
                  	sbrc r16,0			;     r27
                  	rjmp left			; ,       
                  	sbrs r16,0			;     r27
                  	rjmp right			; ,       
right:
                  	out eear,r17			;    EEPROM
                  	sbi eecr,eere			;   EEPROM
                  	in r19,eedr			;   EEPROM  
                  	cbi portd,5			;   PD5 .0
                  	out portb,r19			;     
                  	sbi portd,6			;   PD6 .1
                  	rjmp exit			;    
left:
                  	out eear,r18			;    EEPROM
                  	sbi eecr,eere			;   EEPROM
                  	in r19,eedr			;   EEPROM  
                  	cbi portd,6			;   PD6 .0
                  	out portb,r19			;     
                  	sbi portd,5			;   PD5 .1
                  	rjmp exit			;    
exit:
                  	ret				;  
.EXIT
